# Go API client for swagger

This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III
itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This
file was last generated on 2024-03-16T05:34:43+00:00 Please keep in mind that the demo site does not accept requests
from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out
there, sorry about that.

## Overview

This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project. By using
the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API
client.

- API version: 2.0.12
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.go.GoClientCodegen For more information, please
  visit [https://firefly-iii.org](https://firefly-iii.org)

## Installation

Put the package under your project folder and add the following in import:

```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://demo.firefly-iii.org/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AboutApi* | [**GetAbout**](docs/AboutApi.md#getabout) | **Get** /v1/about | System information end point.
*AboutApi* | [**GetCron**](docs/AboutApi.md#getcron) | **Get** /v1/cron/{cliToken} | Cron job endpoint
*AboutApi* | [**GetCurrentUser**](docs/AboutApi.md#getcurrentuser) | **
Get** /v1/about/user | Currently authenticated user endpoint.
*AccountsApi* | [**DeleteAccount**](docs/AccountsApi.md#deleteaccount) | **
Delete** /v1/accounts/{id} | Permanently delete account.
*AccountsApi* | [**GetAccount**](docs/AccountsApi.md#getaccount) | **Get** /v1/accounts/{id} | Get single account.
*AccountsApi* | [**ListAccount**](docs/AccountsApi.md#listaccount) | **Get** /v1/accounts | List all accounts.
*AccountsApi* | [**ListAttachmentByAccount**](docs/AccountsApi.md#listattachmentbyaccount) | **
Get** /v1/accounts/{id}/attachments | Lists all attachments.
*AccountsApi* | [**ListPiggyBankByAccount**](docs/AccountsApi.md#listpiggybankbyaccount) | **
Get** /v1/accounts/{id}/piggy-banks | List all piggy banks related to the account.
*AccountsApi* | [**ListTransactionByAccount**](docs/AccountsApi.md#listtransactionbyaccount) | **
Get** /v1/accounts/{id}/transactions | List all transactions related to the account.
*AccountsApi* | [**StoreAccount**](docs/AccountsApi.md#storeaccount) | **Post** /v1/accounts | Create new account.
*AccountsApi* | [**UpdateAccount**](docs/AccountsApi.md#updateaccount) | **
Put** /v1/accounts/{id} | Update existing account.
*AttachmentsApi* | [**DeleteAttachment**](docs/AttachmentsApi.md#deleteattachment) | **
Delete** /v1/attachments/{id} | Delete an attachment.
*AttachmentsApi* | [**DownloadAttachment**](docs/AttachmentsApi.md#downloadattachment) | **
Get** /v1/attachments/{id}/download | Download a single attachment.
*AttachmentsApi* | [**GetAttachment**](docs/AttachmentsApi.md#getattachment) | **
Get** /v1/attachments/{id} | Get a single attachment.
*AttachmentsApi* | [**ListAttachment**](docs/AttachmentsApi.md#listattachment) | **
Get** /v1/attachments | List all attachments.
*AttachmentsApi* | [**StoreAttachment**](docs/AttachmentsApi.md#storeattachment) | **
Post** /v1/attachments | Store a new attachment.
*AttachmentsApi* | [**UpdateAttachment**](docs/AttachmentsApi.md#updateattachment) | **
Put** /v1/attachments/{id} | Update existing attachment.
*AttachmentsApi* | [**UploadAttachment**](docs/AttachmentsApi.md#uploadattachment) | **
Post** /v1/attachments/{id}/upload | Upload an attachment.
*AutocompleteApi* | [**GetAccountsAC**](docs/AutocompleteApi.md#getaccountsac) | **
Get** /v1/autocomplete/accounts | Returns all accounts of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetBillsAC**](docs/AutocompleteApi.md#getbillsac) | **
Get** /v1/autocomplete/bills | Returns all bills of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetBudgetsAC**](docs/AutocompleteApi.md#getbudgetsac) | **
Get** /v1/autocomplete/budgets | Returns all budgets of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetCategoriesAC**](docs/AutocompleteApi.md#getcategoriesac) | **
Get** /v1/autocomplete/categories | Returns all categories of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetCurrenciesAC**](docs/AutocompleteApi.md#getcurrenciesac) | **
Get** /v1/autocomplete/currencies | Returns all currencies of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetCurrenciesCodeAC**](docs/AutocompleteApi.md#getcurrenciescodeac) | **
Get** /v1/autocomplete/currencies-with-code | Returns all currencies of the user returned in a basic auto-complete array. This endpoint is DEPRECATED and I suggest you DO NOT use it.
*AutocompleteApi* | [**GetObjectGroupsAC**](docs/AutocompleteApi.md#getobjectgroupsac) | **
Get** /v1/autocomplete/object-groups | Returns all object groups of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetPiggiesAC**](docs/AutocompleteApi.md#getpiggiesac) | **
Get** /v1/autocomplete/piggy-banks | Returns all piggy banks of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetPiggiesBalanceAC**](docs/AutocompleteApi.md#getpiggiesbalanceac) | **
Get** /v1/autocomplete/piggy-banks-with-balance | Returns all piggy banks of the user returned in a basic auto-complete array complemented with balance information.
*AutocompleteApi* | [**GetRecurringAC**](docs/AutocompleteApi.md#getrecurringac) | **
Get** /v1/autocomplete/recurring | Returns all recurring transactions of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetRuleGroupsAC**](docs/AutocompleteApi.md#getrulegroupsac) | **
Get** /v1/autocomplete/rule-groups | Returns all rule groups of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetRulesAC**](docs/AutocompleteApi.md#getrulesac) | **
Get** /v1/autocomplete/rules | Returns all rules of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetTagAC**](docs/AutocompleteApi.md#gettagac) | **
Get** /v1/autocomplete/tags | Returns all tags of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetTransactionTypesAC**](docs/AutocompleteApi.md#gettransactiontypesac) | **
Get** /v1/autocomplete/transaction-types | Returns all transaction types returned in a basic auto-complete array. English only.
*AutocompleteApi* | [**GetTransactionsAC**](docs/AutocompleteApi.md#gettransactionsac) | **
Get** /v1/autocomplete/transactions | Returns all transaction descriptions of the user returned in a basic auto-complete array.
*AutocompleteApi* | [**GetTransactionsIDAC**](docs/AutocompleteApi.md#gettransactionsidac) | **
Get** /v1/autocomplete/transactions-with-id | Returns all transactions, complemented with their ID, of the user returned in a basic auto-complete array. This endpoint is DEPRECATED and I suggest you DO NOT use it.
*AvailableBudgetsApi* | [**GetAvailableBudget**](docs/AvailableBudgetsApi.md#getavailablebudget) | **
Get** /v1/available-budgets/{id} | Get a single available budget.
*AvailableBudgetsApi* | [**ListAvailableBudget**](docs/AvailableBudgetsApi.md#listavailablebudget) | **
Get** /v1/available-budgets | List all available budget amounts.
*BillsApi* | [**DeleteBill**](docs/BillsApi.md#deletebill) | **Delete** /v1/bills/{id} | Delete a bill.
*BillsApi* | [**GetBill**](docs/BillsApi.md#getbill) | **Get** /v1/bills/{id} | Get a single bill.
*BillsApi* | [**ListAttachmentByBill**](docs/BillsApi.md#listattachmentbybill) | **
Get** /v1/bills/{id}/attachments | List all attachments uploaded to the bill.
*BillsApi* | [**ListBill**](docs/BillsApi.md#listbill) | **Get** /v1/bills | List all bills.
*BillsApi* | [**ListRuleByBill**](docs/BillsApi.md#listrulebybill) | **
Get** /v1/bills/{id}/rules | List all rules associated with the bill.
*BillsApi* | [**ListTransactionByBill**](docs/BillsApi.md#listtransactionbybill) | **
Get** /v1/bills/{id}/transactions | List all transactions associated with the  bill.
*BillsApi* | [**StoreBill**](docs/BillsApi.md#storebill) | **Post** /v1/bills | Store a new bill
*BillsApi* | [**UpdateBill**](docs/BillsApi.md#updatebill) | **Put** /v1/bills/{id} | Update existing bill.
*BudgetsApi* | [**DeleteBudget**](docs/BudgetsApi.md#deletebudget) | **Delete** /v1/budgets/{id} | Delete a budget.
*BudgetsApi* | [**DeleteBudgetLimit**](docs/BudgetsApi.md#deletebudgetlimit) | **
Delete** /v1/budgets/{id}/limits/{limitId} | Delete a budget limit.
*BudgetsApi* | [**GetBudget**](docs/BudgetsApi.md#getbudget) | **Get** /v1/budgets/{id} | Get a single budget.
*BudgetsApi* | [**GetBudgetLimit**](docs/BudgetsApi.md#getbudgetlimit) | **
Get** /v1/budgets/{id}/limits/{limitId} | Get single budget limit.
*BudgetsApi* | [**ListAttachmentByBudget**](docs/BudgetsApi.md#listattachmentbybudget) | **
Get** /v1/budgets/{id}/attachments | Lists all attachments of a budget.
*BudgetsApi* | [**ListBudget**](docs/BudgetsApi.md#listbudget) | **Get** /v1/budgets | List all budgets.
*BudgetsApi* | [**ListBudgetLimit**](docs/BudgetsApi.md#listbudgetlimit) | **
Get** /v1/budget-limits | Get list of budget limits by date
*BudgetsApi* | [**ListBudgetLimitByBudget**](docs/BudgetsApi.md#listbudgetlimitbybudget) | **
Get** /v1/budgets/{id}/limits | Get all limits for a budget.
*BudgetsApi* | [**ListTransactionByBudget**](docs/BudgetsApi.md#listtransactionbybudget) | **
Get** /v1/budgets/{id}/transactions | All transactions to a budget.
*BudgetsApi* | [**ListTransactionByBudgetLimit**](docs/BudgetsApi.md#listtransactionbybudgetlimit) | **
Get** /v1/budgets/{id}/limits/{limitId}/transactions | List all transactions by a budget limit ID.
*BudgetsApi* | [**StoreBudget**](docs/BudgetsApi.md#storebudget) | **Post** /v1/budgets | Store a new budget
*BudgetsApi* | [**StoreBudgetLimit**](docs/BudgetsApi.md#storebudgetlimit) | **
Post** /v1/budgets/{id}/limits | Store new budget limit.
*BudgetsApi* | [**UpdateBudget**](docs/BudgetsApi.md#updatebudget) | **Put** /v1/budgets/{id} | Update existing budget.
*BudgetsApi* | [**UpdateBudgetLimit**](docs/BudgetsApi.md#updatebudgetlimit) | **
Put** /v1/budgets/{id}/limits/{limitId} | Update existing budget limit.
*CategoriesApi* | [**DeleteCategory**](docs/CategoriesApi.md#deletecategory) | **
Delete** /v1/categories/{id} | Delete a category.
*CategoriesApi* | [**GetCategory**](docs/CategoriesApi.md#getcategory) | **
Get** /v1/categories/{id} | Get a single category.
*CategoriesApi* | [**ListAttachmentByCategory**](docs/CategoriesApi.md#listattachmentbycategory) | **
Get** /v1/categories/{id}/attachments | Lists all attachments.
*CategoriesApi* | [**ListCategory**](docs/CategoriesApi.md#listcategory) | **Get** /v1/categories | List all categories.
*CategoriesApi* | [**ListTransactionByCategory**](docs/CategoriesApi.md#listtransactionbycategory) | **
Get** /v1/categories/{id}/transactions | List all transactions in a category.
*CategoriesApi* | [**StoreCategory**](docs/CategoriesApi.md#storecategory) | **
Post** /v1/categories | Store a new category
*CategoriesApi* | [**UpdateCategory**](docs/CategoriesApi.md#updatecategory) | **
Put** /v1/categories/{id} | Update existing category.
*ChartsApi* | [**GetChartAccountOverview**](docs/ChartsApi.md#getchartaccountoverview) | **
Get** /v1/chart/account/overview | Dashboard chart with asset account balance information.
*ConfigurationApi* | [**GetConfiguration**](docs/ConfigurationApi.md#getconfiguration) | **
Get** /v1/configuration | Get Firefly III system configuration values.
*ConfigurationApi* | [**GetSingleConfiguration**](docs/ConfigurationApi.md#getsingleconfiguration) | **
Get** /v1/configuration/{name} | Get a single Firefly III system configuration value
*ConfigurationApi* | [**SetConfiguration**](docs/ConfigurationApi.md#setconfiguration) | **
Put** /v1/configuration/{name} | Update configuration value
*CurrenciesApi* | [**DefaultCurrency**](docs/CurrenciesApi.md#defaultcurrency) | **
Post** /v1/currencies/{code}/default | Make currency default currency.
*CurrenciesApi* | [**DeleteCurrency**](docs/CurrenciesApi.md#deletecurrency) | **
Delete** /v1/currencies/{code} | Delete a currency.
*CurrenciesApi* | [**DisableCurrency**](docs/CurrenciesApi.md#disablecurrency) | **
Post** /v1/currencies/{code}/disable | Disable a currency.
*CurrenciesApi* | [**EnableCurrency**](docs/CurrenciesApi.md#enablecurrency) | **
Post** /v1/currencies/{code}/enable | Enable a single currency.
*CurrenciesApi* | [**GetCurrency**](docs/CurrenciesApi.md#getcurrency) | **
Get** /v1/currencies/{code} | Get a single currency.
*CurrenciesApi* | [**GetDefaultCurrency**](docs/CurrenciesApi.md#getdefaultcurrency) | **
Get** /v1/currencies/default | Get the user&#x27;s default currency.
*CurrenciesApi* | [**ListAccountByCurrency**](docs/CurrenciesApi.md#listaccountbycurrency) | **
Get** /v1/currencies/{code}/accounts | List all accounts with this currency.
*CurrenciesApi* | [**ListAvailableBudgetByCurrency**](docs/CurrenciesApi.md#listavailablebudgetbycurrency) | **
Get** /v1/currencies/{code}/available-budgets | List all available budgets with this currency.
*CurrenciesApi* | [**ListBillByCurrency**](docs/CurrenciesApi.md#listbillbycurrency) | **
Get** /v1/currencies/{code}/bills | List all bills with this currency.
*CurrenciesApi* | [**ListBudgetLimitByCurrency**](docs/CurrenciesApi.md#listbudgetlimitbycurrency) | **
Get** /v1/currencies/{code}/budget_limits | List all budget limits with this currency
*CurrenciesApi* | [**ListCurrency**](docs/CurrenciesApi.md#listcurrency) | **Get** /v1/currencies | List all currencies.
*CurrenciesApi* | [**ListRecurrenceByCurrency**](docs/CurrenciesApi.md#listrecurrencebycurrency) | **
Get** /v1/currencies/{code}/recurrences | List all recurring transactions with this currency.
*CurrenciesApi* | [**ListRuleByCurrency**](docs/CurrenciesApi.md#listrulebycurrency) | **
Get** /v1/currencies/{code}/rules | List all rules with this currency.
*CurrenciesApi* | [**ListTransactionByCurrency**](docs/CurrenciesApi.md#listtransactionbycurrency) | **
Get** /v1/currencies/{code}/transactions | List all transactions with this currency.
*CurrenciesApi* | [**StoreCurrency**](docs/CurrenciesApi.md#storecurrency) | **
Post** /v1/currencies | Store a new currency
*CurrenciesApi* | [**UpdateCurrency**](docs/CurrenciesApi.md#updatecurrency) | **
Put** /v1/currencies/{code} | Update existing currency.
*DataApi* | [**BulkUpdateTransactions**](docs/DataApi.md#bulkupdatetransactions) | **
Post** /v1/data/bulk/transactions | Bulk update transaction properties. For more information, see https://docs.firefly-iii.org/references/firefly-iii/api/specials/
*DataApi* | [**DestroyData**](docs/DataApi.md#destroydata) | **Delete** /v1/data/destroy | Endpoint to destroy user data
*DataApi* | [**ExportAccounts**](docs/DataApi.md#exportaccounts) | **
Get** /v1/data/export/accounts | Export account data from Firefly III
*DataApi* | [**ExportBills**](docs/DataApi.md#exportbills) | **
Get** /v1/data/export/bills | Export bills from Firefly III
*DataApi* | [**ExportBudgets**](docs/DataApi.md#exportbudgets) | **
Get** /v1/data/export/budgets | Export budgets and budget amount data from Firefly III
*DataApi* | [**ExportCategories**](docs/DataApi.md#exportcategories) | **
Get** /v1/data/export/categories | Export category data from Firefly III
*DataApi* | [**ExportPiggies**](docs/DataApi.md#exportpiggies) | **
Get** /v1/data/export/piggy-banks | Export piggy banks from Firefly III
*DataApi* | [**ExportRecurring**](docs/DataApi.md#exportrecurring) | **
Get** /v1/data/export/recurring | Export recurring transaction data from Firefly III
*DataApi* | [**ExportRules**](docs/DataApi.md#exportrules) | **
Get** /v1/data/export/rules | Export rule groups and rule data from Firefly III
*DataApi* | [**ExportTags**](docs/DataApi.md#exporttags) | **
Get** /v1/data/export/tags | Export tag data from Firefly III
*DataApi* | [**ExportTransactions**](docs/DataApi.md#exporttransactions) | **
Get** /v1/data/export/transactions | Export transaction data from Firefly III
*DataApi* | [**PurgeData**](docs/DataApi.md#purgedata) | **Delete** /v1/data/purge | Endpoint to purge user data
*InsightApi* | [**InsightExpenseAsset**](docs/InsightApi.md#insightexpenseasset) | **
Get** /v1/insight/expense/asset | Insight into expenses, grouped by asset account.
*InsightApi* | [**InsightExpenseBill**](docs/InsightApi.md#insightexpensebill) | **
Get** /v1/insight/expense/bill | Insight into expenses, grouped by bill.
*InsightApi* | [**InsightExpenseBudget**](docs/InsightApi.md#insightexpensebudget) | **
Get** /v1/insight/expense/budget | Insight into expenses, grouped by budget.
*InsightApi* | [**InsightExpenseCategory**](docs/InsightApi.md#insightexpensecategory) | **
Get** /v1/insight/expense/category | Insight into expenses, grouped by category.
*InsightApi* | [**InsightExpenseExpense**](docs/InsightApi.md#insightexpenseexpense) | **
Get** /v1/insight/expense/expense | Insight into expenses, grouped by expense account.
*InsightApi* | [**InsightExpenseNoBill**](docs/InsightApi.md#insightexpensenobill) | **
Get** /v1/insight/expense/no-bill | Insight into expenses, without bill.
*InsightApi* | [**InsightExpenseNoBudget**](docs/InsightApi.md#insightexpensenobudget) | **
Get** /v1/insight/expense/no-budget | Insight into expenses, without budget.
*InsightApi* | [**InsightExpenseNoCategory**](docs/InsightApi.md#insightexpensenocategory) | **
Get** /v1/insight/expense/no-category | Insight into expenses, without category.
*InsightApi* | [**InsightExpenseNoTag**](docs/InsightApi.md#insightexpensenotag) | **
Get** /v1/insight/expense/no-tag | Insight into expenses, without tag.
*InsightApi* | [**InsightExpenseTag**](docs/InsightApi.md#insightexpensetag) | **
Get** /v1/insight/expense/tag | Insight into expenses, grouped by tag.
*InsightApi* | [**InsightExpenseTotal**](docs/InsightApi.md#insightexpensetotal) | **
Get** /v1/insight/expense/total | Insight into total expenses.
*InsightApi* | [**InsightIncomeAsset**](docs/InsightApi.md#insightincomeasset) | **
Get** /v1/insight/income/asset | Insight into income, grouped by asset account.
*InsightApi* | [**InsightIncomeCategory**](docs/InsightApi.md#insightincomecategory) | **
Get** /v1/insight/income/category | Insight into income, grouped by category.
*InsightApi* | [**InsightIncomeNoCategory**](docs/InsightApi.md#insightincomenocategory) | **
Get** /v1/insight/income/no-category | Insight into income, without category.
*InsightApi* | [**InsightIncomeNoTag**](docs/InsightApi.md#insightincomenotag) | **
Get** /v1/insight/income/no-tag | Insight into income, without tag.
*InsightApi* | [**InsightIncomeRevenue**](docs/InsightApi.md#insightincomerevenue) | **
Get** /v1/insight/income/revenue | Insight into income, grouped by revenue account.
*InsightApi* | [**InsightIncomeTag**](docs/InsightApi.md#insightincometag) | **
Get** /v1/insight/income/tag | Insight into income, grouped by tag.
*InsightApi* | [**InsightIncomeTotal**](docs/InsightApi.md#insightincometotal) | **
Get** /v1/insight/income/total | Insight into total income.
*InsightApi* | [**InsightTransferCategory**](docs/InsightApi.md#insighttransfercategory) | **
Get** /v1/insight/transfer/category | Insight into transfers, grouped by category.
*InsightApi* | [**InsightTransferNoCategory**](docs/InsightApi.md#insighttransfernocategory) | **
Get** /v1/insight/transfer/no-category | Insight into transfers, without category.
*InsightApi* | [**InsightTransferNoTag**](docs/InsightApi.md#insighttransfernotag) | **
Get** /v1/insight/transfer/no-tag | Insight into expenses, without tag.
*InsightApi* | [**InsightTransferTag**](docs/InsightApi.md#insighttransfertag) | **
Get** /v1/insight/transfer/tag | Insight into transfers, grouped by tag.
*InsightApi* | [**InsightTransferTotal**](docs/InsightApi.md#insighttransfertotal) | **
Get** /v1/insight/transfer/total | Insight into total transfers.
*InsightApi* | [**InsightTransfers**](docs/InsightApi.md#insighttransfers) | **
Get** /v1/insight/transfer/asset | Insight into transfers, grouped by account.
*LinksApi* | [**DeleteLinkType**](docs/LinksApi.md#deletelinktype) | **
Delete** /v1/link-types/{id} | Permanently delete link type.
*LinksApi* | [**DeleteTransactionLink**](docs/LinksApi.md#deletetransactionlink) | **
Delete** /v1/transaction-links/{id} | Permanently delete link between transactions.
*LinksApi* | [**GetLinkType**](docs/LinksApi.md#getlinktype) | **Get** /v1/link-types/{id} | Get single a link type.
*LinksApi* | [**GetTransactionLink**](docs/LinksApi.md#gettransactionlink) | **
Get** /v1/transaction-links/{id} | Get a single link.
*LinksApi* | [**ListLinkType**](docs/LinksApi.md#listlinktype) | **Get** /v1/link-types | List all types of links.
*LinksApi* | [**ListTransactionByLinkType**](docs/LinksApi.md#listtransactionbylinktype) | **
Get** /v1/link-types/{id}/transactions | List all transactions under this link type.
*LinksApi* | [**ListTransactionLink**](docs/LinksApi.md#listtransactionlink) | **
Get** /v1/transaction-links | List all transaction links.
*LinksApi* | [**StoreLinkType**](docs/LinksApi.md#storelinktype) | **Post** /v1/link-types | Create a new link type
*LinksApi* | [**StoreTransactionLink**](docs/LinksApi.md#storetransactionlink) | **
Post** /v1/transaction-links | Create a new link between transactions
*LinksApi* | [**UpdateLinkType**](docs/LinksApi.md#updatelinktype) | **
Put** /v1/link-types/{id} | Update existing link type.
*LinksApi* | [**UpdateTransactionLink**](docs/LinksApi.md#updatetransactionlink) | **
Put** /v1/transaction-links/{id} | Update an existing link between transactions.
*ObjectGroupsApi* | [**DeleteObjectGroup**](docs/ObjectGroupsApi.md#deleteobjectgroup) | **
Delete** /v1/object-groups/{id} | Delete a object group.
*ObjectGroupsApi* | [**GetObjectGroup**](docs/ObjectGroupsApi.md#getobjectgroup) | **
Get** /v1/object-groups/{id} | Get a single object group.
*ObjectGroupsApi* | [**ListBillByObjectGroup**](docs/ObjectGroupsApi.md#listbillbyobjectgroup) | **
Get** /v1/object-groups/{id}/bills | List all bills with this object group.
*ObjectGroupsApi* | [**ListObjectGroups**](docs/ObjectGroupsApi.md#listobjectgroups) | **
Get** /v1/object-groups | List all oject groups.
*ObjectGroupsApi* | [**ListPiggyBankByObjectGroup**](docs/ObjectGroupsApi.md#listpiggybankbyobjectgroup) | **
Get** /v1/object-groups/{id}/piggy-banks | List all piggy banks related to the object group.
*ObjectGroupsApi* | [**UpdateObjectGroup**](docs/ObjectGroupsApi.md#updateobjectgroup) | **
Put** /v1/object-groups/{id} | Update existing object group.
*PiggyBanksApi* | [**DeletePiggyBank**](docs/PiggyBanksApi.md#deletepiggybank) | **
Delete** /v1/piggy-banks/{id} | Delete a piggy bank.
*PiggyBanksApi* | [**GetPiggyBank**](docs/PiggyBanksApi.md#getpiggybank) | **
Get** /v1/piggy-banks/{id} | Get a single piggy bank.
*PiggyBanksApi* | [**ListAttachmentByPiggyBank**](docs/PiggyBanksApi.md#listattachmentbypiggybank) | **
Get** /v1/piggy-banks/{id}/attachments | Lists all attachments.
*PiggyBanksApi* | [**ListEventByPiggyBank**](docs/PiggyBanksApi.md#listeventbypiggybank) | **
Get** /v1/piggy-banks/{id}/events | List all events linked to a piggy bank.
*PiggyBanksApi* | [**ListPiggyBank**](docs/PiggyBanksApi.md#listpiggybank) | **
Get** /v1/piggy-banks | List all piggy banks.
*PiggyBanksApi* | [**StorePiggyBank**](docs/PiggyBanksApi.md#storepiggybank) | **
Post** /v1/piggy-banks | Store a new piggy bank
*PiggyBanksApi* | [**UpdatePiggyBank**](docs/PiggyBanksApi.md#updatepiggybank) | **
Put** /v1/piggy-banks/{id} | Update existing piggy bank.
*PreferencesApi* | [**GetPreference**](docs/PreferencesApi.md#getpreference) | **
Get** /v1/preferences/{name} | Return a single preference.
*PreferencesApi* | [**ListPreference**](docs/PreferencesApi.md#listpreference) | **
Get** /v1/preferences | List all users preferences.
*PreferencesApi* | [**StorePreference**](docs/PreferencesApi.md#storepreference) | **
Post** /v1/preferences | Store a new preference for this user.
*PreferencesApi* | [**UpdatePreference**](docs/PreferencesApi.md#updatepreference) | **
Put** /v1/preferences/{name} | Update preference
*RecurrencesApi* | [**DeleteRecurrence**](docs/RecurrencesApi.md#deleterecurrence) | **
Delete** /v1/recurrences/{id} | Delete a recurring transaction.
*RecurrencesApi* | [**GetRecurrence**](docs/RecurrencesApi.md#getrecurrence) | **
Get** /v1/recurrences/{id} | Get a single recurring transaction.
*RecurrencesApi* | [**ListRecurrence**](docs/RecurrencesApi.md#listrecurrence) | **
Get** /v1/recurrences | List all recurring transactions.
*RecurrencesApi* | [**ListTransactionByRecurrence**](docs/RecurrencesApi.md#listtransactionbyrecurrence) | **
Get** /v1/recurrences/{id}/transactions | List all transactions created by a recurring transaction.
*RecurrencesApi* | [**StoreRecurrence**](docs/RecurrencesApi.md#storerecurrence) | **
Post** /v1/recurrences | Store a new recurring transaction
*RecurrencesApi* | [**UpdateRecurrence**](docs/RecurrencesApi.md#updaterecurrence) | **
Put** /v1/recurrences/{id} | Update existing recurring transaction.
*RuleGroupsApi* | [**DeleteRuleGroup**](docs/RuleGroupsApi.md#deleterulegroup) | **
Delete** /v1/rule-groups/{id} | Delete a rule group.
*RuleGroupsApi* | [**FireRuleGroup**](docs/RuleGroupsApi.md#firerulegroup) | **
Post** /v1/rule-groups/{id}/trigger | Fire the rule group on your transactions.
*RuleGroupsApi* | [**GetRuleGroup**](docs/RuleGroupsApi.md#getrulegroup) | **
Get** /v1/rule-groups/{id} | Get a single rule group.
*RuleGroupsApi* | [**ListRuleByGroup**](docs/RuleGroupsApi.md#listrulebygroup) | **
Get** /v1/rule-groups/{id}/rules | List rules in this rule group.
*RuleGroupsApi* | [**ListRuleGroup**](docs/RuleGroupsApi.md#listrulegroup) | **
Get** /v1/rule-groups | List all rule groups.
*RuleGroupsApi* | [**StoreRuleGroup**](docs/RuleGroupsApi.md#storerulegroup) | **
Post** /v1/rule-groups | Store a new rule group.
*RuleGroupsApi* | [**TestRuleGroup**](docs/RuleGroupsApi.md#testrulegroup) | **
Get** /v1/rule-groups/{id}/test | Test which transactions would be hit by the rule group. No changes will be made.
*RuleGroupsApi* | [**UpdateRuleGroup**](docs/RuleGroupsApi.md#updaterulegroup) | **
Put** /v1/rule-groups/{id} | Update existing rule group.
*RulesApi* | [**DeleteRule**](docs/RulesApi.md#deleterule) | **Delete** /v1/rules/{id} | Delete an rule.
*RulesApi* | [**FireRule**](docs/RulesApi.md#firerule) | **
Post** /v1/rules/{id}/trigger | Fire the rule on your transactions.
*RulesApi* | [**GetRule**](docs/RulesApi.md#getrule) | **Get** /v1/rules/{id} | Get a single rule.
*RulesApi* | [**ListRule**](docs/RulesApi.md#listrule) | **Get** /v1/rules | List all rules.
*RulesApi* | [**StoreRule**](docs/RulesApi.md#storerule) | **Post** /v1/rules | Store a new rule
*RulesApi* | [**TestRule**](docs/RulesApi.md#testrule) | **
Get** /v1/rules/{id}/test | Test which transactions would be hit by the rule. No changes will be made.
*RulesApi* | [**UpdateRule**](docs/RulesApi.md#updaterule) | **Put** /v1/rules/{id} | Update existing rule.
*SearchApi* | [**SearchAccounts**](docs/SearchApi.md#searchaccounts) | **Get** /v1/search/accounts | Search for accounts
*SearchApi* | [**SearchTransactions**](docs/SearchApi.md#searchtransactions) | **
Get** /v1/search/transactions | Search for transactions
*SummaryApi* | [**GetBasicSummary**](docs/SummaryApi.md#getbasicsummary) | **
Get** /v1/summary/basic | Returns basic sums of the users data.
*TagsApi* | [**DeleteTag**](docs/TagsApi.md#deletetag) | **Delete** /v1/tags/{tag} | Delete an tag.
*TagsApi* | [**GetTag**](docs/TagsApi.md#gettag) | **Get** /v1/tags/{tag} | Get a single tag.
*TagsApi* | [**ListAttachmentByTag**](docs/TagsApi.md#listattachmentbytag) | **
Get** /v1/tags/{tag}/attachments | Lists all attachments.
*TagsApi* | [**ListTag**](docs/TagsApi.md#listtag) | **Get** /v1/tags | List all tags.
*TagsApi* | [**ListTransactionByTag**](docs/TagsApi.md#listtransactionbytag) | **
Get** /v1/tags/{tag}/transactions | List all transactions with this tag.
*TagsApi* | [**StoreTag**](docs/TagsApi.md#storetag) | **Post** /v1/tags | Store a new tag
*TagsApi* | [**UpdateTag**](docs/TagsApi.md#updatetag) | **Put** /v1/tags/{tag} | Update existing tag.
*TransactionsApi* | [**DeleteTransaction**](docs/TransactionsApi.md#deletetransaction) | **
Delete** /v1/transactions/{id} | Delete a transaction.
*TransactionsApi* | [**DeleteTransactionJournal**](docs/TransactionsApi.md#deletetransactionjournal) | **
Delete** /v1/transaction-journals/{id} | Delete split from transaction
*TransactionsApi* | [**GetTransaction**](docs/TransactionsApi.md#gettransaction) | **
Get** /v1/transactions/{id} | Get a single transaction.
*TransactionsApi* | [**GetTransactionByJournal**](docs/TransactionsApi.md#gettransactionbyjournal) | **
Get** /v1/transaction-journals/{id} | Get a single transaction, based on one of the underlying transaction journals (transaction splits).
*TransactionsApi* | [**ListAttachmentByTransaction**](docs/TransactionsApi.md#listattachmentbytransaction) | **
Get** /v1/transactions/{id}/attachments | Lists all attachments.
*TransactionsApi* | [**ListEventByTransaction**](docs/TransactionsApi.md#listeventbytransaction) | **
Get** /v1/transactions/{id}/piggy-bank-events | Lists all piggy bank events.
*TransactionsApi* | [**ListLinksByJournal**](docs/TransactionsApi.md#listlinksbyjournal) | **
Get** /v1/transaction-journals/{id}/links | Lists all the transaction links for an individual journal (individual split).
*TransactionsApi* | [**ListTransaction**](docs/TransactionsApi.md#listtransaction) | **
Get** /v1/transactions | List all the user&#x27;s transactions.
*TransactionsApi* | [**StoreTransaction**](docs/TransactionsApi.md#storetransaction) | **
Post** /v1/transactions | Store a new transaction
*TransactionsApi* | [**UpdateTransaction**](docs/TransactionsApi.md#updatetransaction) | **
Put** /v1/transactions/{id} | Update existing transaction. For more information, see https://docs.firefly-iii.org/references/firefly-iii/api/specials/
*UsersApi* | [**DeleteUser**](docs/UsersApi.md#deleteuser) | **Delete** /v1/users/{id} | Delete a user.
*UsersApi* | [**GetUser**](docs/UsersApi.md#getuser) | **Get** /v1/users/{id} | Get a single user.
*UsersApi* | [**ListUser**](docs/UsersApi.md#listuser) | **Get** /v1/users | List all users.
*UsersApi* | [**StoreUser**](docs/UsersApi.md#storeuser) | **Post** /v1/users | Store a new user
*UsersApi* | [**UpdateUser**](docs/UsersApi.md#updateuser) | **
Put** /v1/users/{id} | Update an existing user&#x27;s information.
*WebhooksApi* | [**DeleteWebhook**](docs/WebhooksApi.md#deletewebhook) | **
Delete** /v1/webhooks/{id} | Delete a webhook.
*WebhooksApi* | [**DeleteWebhookMessage**](docs/WebhooksApi.md#deletewebhookmessage) | **
Delete** /v1/webhooks/{id}/messages/{messageId} | Delete a webhook message.
*WebhooksApi* | [**DeleteWebhookMessageAttempt**](docs/WebhooksApi.md#deletewebhookmessageattempt) | **
Delete** /v1/webhooks/{id}/messages/{messageId}/attempts/{attemptId} | Delete a webhook attempt.
*WebhooksApi* | [**GetSingleWebhookMessage**](docs/WebhooksApi.md#getsinglewebhookmessage) | **
Get** /v1/webhooks/{id}/messages/{messageId} | Get a single message from a webhook.
*WebhooksApi* | [**GetSingleWebhookMessageAttempt**](docs/WebhooksApi.md#getsinglewebhookmessageattempt) | **
Get** /v1/webhooks/{id}/messages/{messageId}/attempts/{attemptId} | Get a single failed attempt from a single webhook message.
*WebhooksApi* | [**GetWebhook**](docs/WebhooksApi.md#getwebhook) | **Get** /v1/webhooks/{id} | Get a single webhook.
*WebhooksApi* | [**GetWebhookMessageAttempts**](docs/WebhooksApi.md#getwebhookmessageattempts) | **
Get** /v1/webhooks/{id}/messages/{messageId}/attempts | Get all the failed attempts of a single webhook message.
*WebhooksApi* | [**GetWebhookMessages**](docs/WebhooksApi.md#getwebhookmessages) | **
Get** /v1/webhooks/{id}/messages | Get all the messages of a single webhook.
*WebhooksApi* | [**ListWebhook**](docs/WebhooksApi.md#listwebhook) | **Get** /v1/webhooks | List all webhooks.
*WebhooksApi* | [**StoreWebhook**](docs/WebhooksApi.md#storewebhook) | **Post** /v1/webhooks | Store a new webhook
*WebhooksApi* | [**SubmitWebook**](docs/WebhooksApi.md#submitwebook) | **
Post** /v1/webhooks/{id}/submit | Submit messages for a webhook.
*WebhooksApi* | [**TriggerTransactionWebhook**](docs/WebhooksApi.md#triggertransactionwebhook) | **
Post** /v1/webhooks/{id}/trigger-transaction/{transactionId} | Trigger webhook for a given transaction.
*WebhooksApi* | [**UpdateWebhook**](docs/WebhooksApi.md#updatewebhook) | **
Put** /v1/webhooks/{id} | Update existing webhook.

## Documentation For Models

- [Account](docs/Account.md)
- [AccountArray](docs/AccountArray.md)
- [AccountRead](docs/AccountRead.md)
- [AccountRoleProperty](docs/AccountRoleProperty.md)
- [AccountSearchFieldFilter](docs/AccountSearchFieldFilter.md)
- [AccountSingle](docs/AccountSingle.md)
- [AccountStore](docs/AccountStore.md)
- [AccountTypeFilter](docs/AccountTypeFilter.md)
- [AccountTypeProperty](docs/AccountTypeProperty.md)
- [AccountUpdate](docs/AccountUpdate.md)
- [AttachableType](docs/AttachableType.md)
- [Attachment](docs/Attachment.md)
- [AttachmentArray](docs/AttachmentArray.md)
- [AttachmentRead](docs/AttachmentRead.md)
- [AttachmentSingle](docs/AttachmentSingle.md)
- [AttachmentStore](docs/AttachmentStore.md)
- [AttachmentUpdate](docs/AttachmentUpdate.md)
- [AutoBudgetPeriod](docs/AutoBudgetPeriod.md)
- [AutoBudgetType](docs/AutoBudgetType.md)
- [AutocompleteAccount](docs/AutocompleteAccount.md)
- [AutocompleteBill](docs/AutocompleteBill.md)
- [AutocompleteBudget](docs/AutocompleteBudget.md)
- [AutocompleteCategory](docs/AutocompleteCategory.md)
- [AutocompleteCurrency](docs/AutocompleteCurrency.md)
- [AutocompleteCurrencyCode](docs/AutocompleteCurrencyCode.md)
- [AutocompleteObjectGroup](docs/AutocompleteObjectGroup.md)
- [AutocompletePiggy](docs/AutocompletePiggy.md)
- [AutocompletePiggyBalance](docs/AutocompletePiggyBalance.md)
- [AutocompleteRecurrence](docs/AutocompleteRecurrence.md)
- [AutocompleteRule](docs/AutocompleteRule.md)
- [AutocompleteRuleGroup](docs/AutocompleteRuleGroup.md)
- [AutocompleteTag](docs/AutocompleteTag.md)
- [AutocompleteTransaction](docs/AutocompleteTransaction.md)
- [AutocompleteTransactionId](docs/AutocompleteTransactionId.md)
- [AutocompleteTransactionType](docs/AutocompleteTransactionType.md)
- [AvailableBudget](docs/AvailableBudget.md)
- [AvailableBudgetArray](docs/AvailableBudgetArray.md)
- [AvailableBudgetRead](docs/AvailableBudgetRead.md)
- [AvailableBudgetSingle](docs/AvailableBudgetSingle.md)
- [BadRequestResponse](docs/BadRequestResponse.md)
- [BasicSummaryEntry](docs/BasicSummaryEntry.md)
- [Bill](docs/Bill.md)
- [BillArray](docs/BillArray.md)
- [BillPaidDates](docs/BillPaidDates.md)
- [BillRead](docs/BillRead.md)
- [BillRepeatFrequency](docs/BillRepeatFrequency.md)
- [BillSingle](docs/BillSingle.md)
- [BillStore](docs/BillStore.md)
- [BillUpdate](docs/BillUpdate.md)
- [Budget](docs/Budget.md)
- [BudgetArray](docs/BudgetArray.md)
- [BudgetLimit](docs/BudgetLimit.md)
- [BudgetLimitArray](docs/BudgetLimitArray.md)
- [BudgetLimitRead](docs/BudgetLimitRead.md)
- [BudgetLimitSingle](docs/BudgetLimitSingle.md)
- [BudgetLimitStore](docs/BudgetLimitStore.md)
- [BudgetRead](docs/BudgetRead.md)
- [BudgetSingle](docs/BudgetSingle.md)
- [BudgetSpent](docs/BudgetSpent.md)
- [BudgetStore](docs/BudgetStore.md)
- [BudgetUpdate](docs/BudgetUpdate.md)
- [Category](docs/Category.md)
- [CategoryArray](docs/CategoryArray.md)
- [CategoryEarned](docs/CategoryEarned.md)
- [CategoryRead](docs/CategoryRead.md)
- [CategorySingle](docs/CategorySingle.md)
- [CategorySpent](docs/CategorySpent.md)
- [CategoryUpdate](docs/CategoryUpdate.md)
- [ChartDataPoint](docs/ChartDataPoint.md)
- [ChartDataSet](docs/ChartDataSet.md)
- [ConfigValueFilter](docs/ConfigValueFilter.md)
- [ConfigValueUpdateFilter](docs/ConfigValueUpdateFilter.md)
- [Configuration](docs/Configuration.md)
- [ConfigurationSingle](docs/ConfigurationSingle.md)
- [ConfigurationUpdate](docs/ConfigurationUpdate.md)
- [CreditCardTypeProperty](docs/CreditCardTypeProperty.md)
- [CronResult](docs/CronResult.md)
- [CronResultRow](docs/CronResultRow.md)
- [Currency](docs/Currency.md)
- [CurrencyArray](docs/CurrencyArray.md)
- [CurrencyRead](docs/CurrencyRead.md)
- [CurrencySingle](docs/CurrencySingle.md)
- [CurrencyStore](docs/CurrencyStore.md)
- [CurrencyUpdate](docs/CurrencyUpdate.md)
- [DataDestroyObject](docs/DataDestroyObject.md)
- [ExportFileFilter](docs/ExportFileFilter.md)
- [InsightGroupEntry](docs/InsightGroupEntry.md)
- [InsightTotalEntry](docs/InsightTotalEntry.md)
- [InsightTransferEntry](docs/InsightTransferEntry.md)
- [InterestPeriodProperty](docs/InterestPeriodProperty.md)
- [InternalExceptionResponse](docs/InternalExceptionResponse.md)
- [LiabilityDirectionProperty](docs/LiabilityDirectionProperty.md)
- [LiabilityTypeProperty](docs/LiabilityTypeProperty.md)
- [LinkType](docs/LinkType.md)
- [LinkTypeArray](docs/LinkTypeArray.md)
- [LinkTypeRead](docs/LinkTypeRead.md)
- [LinkTypeSingle](docs/LinkTypeSingle.md)
- [LinkTypeUpdate](docs/LinkTypeUpdate.md)
- [Meta](docs/Meta.md)
- [MetaPagination](docs/MetaPagination.md)
- [NotFoundResponse](docs/NotFoundResponse.md)
- [ObjectGroup](docs/ObjectGroup.md)
- [ObjectGroupArray](docs/ObjectGroupArray.md)
- [ObjectGroupRead](docs/ObjectGroupRead.md)
- [ObjectGroupSingle](docs/ObjectGroupSingle.md)
- [ObjectGroupUpdate](docs/ObjectGroupUpdate.md)
- [ObjectLink](docs/ObjectLink.md)
- [ObjectLink0](docs/ObjectLink0.md)
- [PageLink](docs/PageLink.md)
- [PiggyBank](docs/PiggyBank.md)
- [PiggyBankArray](docs/PiggyBankArray.md)
- [PiggyBankEvent](docs/PiggyBankEvent.md)
- [PiggyBankEventArray](docs/PiggyBankEventArray.md)
- [PiggyBankEventRead](docs/PiggyBankEventRead.md)
- [PiggyBankRead](docs/PiggyBankRead.md)
- [PiggyBankSingle](docs/PiggyBankSingle.md)
- [PiggyBankStore](docs/PiggyBankStore.md)
- [PiggyBankUpdate](docs/PiggyBankUpdate.md)
- [PolymorphicProperty](docs/PolymorphicProperty.md)
- [Preference](docs/Preference.md)
- [PreferenceArray](docs/PreferenceArray.md)
- [PreferenceRead](docs/PreferenceRead.md)
- [PreferenceSingle](docs/PreferenceSingle.md)
- [PreferenceUpdate](docs/PreferenceUpdate.md)
- [Recurrence](docs/Recurrence.md)
- [RecurrenceArray](docs/RecurrenceArray.md)
- [RecurrenceRead](docs/RecurrenceRead.md)
- [RecurrenceRepetition](docs/RecurrenceRepetition.md)
- [RecurrenceRepetitionStore](docs/RecurrenceRepetitionStore.md)
- [RecurrenceRepetitionType](docs/RecurrenceRepetitionType.md)
- [RecurrenceRepetitionUpdate](docs/RecurrenceRepetitionUpdate.md)
- [RecurrenceSingle](docs/RecurrenceSingle.md)
- [RecurrenceStore](docs/RecurrenceStore.md)
- [RecurrenceTransaction](docs/RecurrenceTransaction.md)
- [RecurrenceTransactionStore](docs/RecurrenceTransactionStore.md)
- [RecurrenceTransactionType](docs/RecurrenceTransactionType.md)
- [RecurrenceTransactionUpdate](docs/RecurrenceTransactionUpdate.md)
- [RecurrenceUpdate](docs/RecurrenceUpdate.md)
- [Rule](docs/Rule.md)
- [RuleAction](docs/RuleAction.md)
- [RuleActionKeyword](docs/RuleActionKeyword.md)
- [RuleActionStore](docs/RuleActionStore.md)
- [RuleActionUpdate](docs/RuleActionUpdate.md)
- [RuleArray](docs/RuleArray.md)
- [RuleGroup](docs/RuleGroup.md)
- [RuleGroupArray](docs/RuleGroupArray.md)
- [RuleGroupRead](docs/RuleGroupRead.md)
- [RuleGroupSingle](docs/RuleGroupSingle.md)
- [RuleGroupStore](docs/RuleGroupStore.md)
- [RuleGroupUpdate](docs/RuleGroupUpdate.md)
- [RuleRead](docs/RuleRead.md)
- [RuleSingle](docs/RuleSingle.md)
- [RuleStore](docs/RuleStore.md)
- [RuleTrigger](docs/RuleTrigger.md)
- [RuleTriggerKeyword](docs/RuleTriggerKeyword.md)
- [RuleTriggerStore](docs/RuleTriggerStore.md)
- [RuleTriggerType](docs/RuleTriggerType.md)
- [RuleTriggerUpdate](docs/RuleTriggerUpdate.md)
- [RuleUpdate](docs/RuleUpdate.md)
- [ShortAccountTypeProperty](docs/ShortAccountTypeProperty.md)
- [SystemInfo](docs/SystemInfo.md)
- [SystemInfoData](docs/SystemInfoData.md)
- [TagArray](docs/TagArray.md)
- [TagModel](docs/TagModel.md)
- [TagModelStore](docs/TagModelStore.md)
- [TagModelUpdate](docs/TagModelUpdate.md)
- [TagRead](docs/TagRead.md)
- [TagSingle](docs/TagSingle.md)
- [Transaction](docs/Transaction.md)
- [TransactionArray](docs/TransactionArray.md)
- [TransactionLink](docs/TransactionLink.md)
- [TransactionLinkArray](docs/TransactionLinkArray.md)
- [TransactionLinkRead](docs/TransactionLinkRead.md)
- [TransactionLinkSingle](docs/TransactionLinkSingle.md)
- [TransactionLinkStore](docs/TransactionLinkStore.md)
- [TransactionLinkUpdate](docs/TransactionLinkUpdate.md)
- [TransactionRead](docs/TransactionRead.md)
- [TransactionSingle](docs/TransactionSingle.md)
- [TransactionSplit](docs/TransactionSplit.md)
- [TransactionSplitStore](docs/TransactionSplitStore.md)
- [TransactionSplitUpdate](docs/TransactionSplitUpdate.md)
- [TransactionStore](docs/TransactionStore.md)
- [TransactionTypeFilter](docs/TransactionTypeFilter.md)
- [TransactionTypeProperty](docs/TransactionTypeProperty.md)
- [TransactionUpdate](docs/TransactionUpdate.md)
- [UnauthenticatedResponse](docs/UnauthenticatedResponse.md)
- [User](docs/User.md)
- [UserArray](docs/UserArray.md)
- [UserBlockedCodeProperty](docs/UserBlockedCodeProperty.md)
- [UserRead](docs/UserRead.md)
- [UserRoleProperty](docs/UserRoleProperty.md)
- [UserSingle](docs/UserSingle.md)
- [ValidationErrorResponse](docs/ValidationErrorResponse.md)
- [ValidationErrorResponseErrors](docs/ValidationErrorResponseErrors.md)
- [Webhook](docs/Webhook.md)
- [WebhookArray](docs/WebhookArray.md)
- [WebhookAttempt](docs/WebhookAttempt.md)
- [WebhookAttemptArray](docs/WebhookAttemptArray.md)
- [WebhookAttemptRead](docs/WebhookAttemptRead.md)
- [WebhookAttemptSingle](docs/WebhookAttemptSingle.md)
- [WebhookDelivery](docs/WebhookDelivery.md)
- [WebhookMessage](docs/WebhookMessage.md)
- [WebhookMessageArray](docs/WebhookMessageArray.md)
- [WebhookMessageRead](docs/WebhookMessageRead.md)
- [WebhookMessageSingle](docs/WebhookMessageSingle.md)
- [WebhookRead](docs/WebhookRead.md)
- [WebhookResponse](docs/WebhookResponse.md)
- [WebhookSingle](docs/WebhookSingle.md)
- [WebhookStore](docs/WebhookStore.md)
- [WebhookTrigger](docs/WebhookTrigger.md)
- [WebhookUpdate](docs/WebhookUpdate.md)

## Documentation For Authorization

## firefly_iii_auth

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://demo.firefly-iii.org/oauth/authorize
- **Scopes**:

Example

```golang
auth := context.WithValue(context.Background(), sw.ContextAccessToken, "ACCESSTOKENSTRING")
r, err := client.Service.Operation(auth, args)
```

Or via OAuth2 module to automatically refresh tokens and perform user authentication.

```golang
import "golang.org/x/oauth2"

/* Perform OAuth2 round trip request and obtain a token */

tokenSource := oauth2cfg.TokenSource(createContext(httpClient), &token)
auth := context.WithValue(oauth2.NoContext, sw.ContextOAuth2, tokenSource)
r, err := client.Service.Operation(auth, args)
```

## local_bearer_auth

## Author

james@firefly-iii.org
