/*
 * Firefly III API v2.0.12
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-03-16T05:34:43+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that.
 *
 * API version: 2.0.12
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package firefly3

import (
	"time"
)

type AccountStore struct {
	Name          string                    `json:"name"`
	Type_         *ShortAccountTypeProperty `json:"type"`
	Iban          string                    `json:"iban,omitempty"`
	Bic           string                    `json:"bic,omitempty"`
	AccountNumber string                    `json:"account_number,omitempty"`
	// Represents the opening balance, the initial amount this account holds.
	OpeningBalance string `json:"opening_balance,omitempty"`
	// Represents the date of the opening balance.
	OpeningBalanceDate time.Time `json:"opening_balance_date,omitempty"`
	VirtualBalance     string    `json:"virtual_balance,omitempty"`
	// Use either currency_id or currency_code. Defaults to the user's default currency.
	CurrencyId string `json:"currency_id,omitempty"`
	// Use either currency_id or currency_code. Defaults to the user's default currency.
	CurrencyCode string `json:"currency_code,omitempty"`
	// If omitted, defaults to true.
	Active bool `json:"active,omitempty"`
	// Order of the account
	Order int32 `json:"order,omitempty"`
	// If omitted, defaults to true.
	IncludeNetWorth bool                    `json:"include_net_worth,omitempty"`
	AccountRole     *AccountRoleProperty    `json:"account_role,omitempty"`
	CreditCardType  *CreditCardTypeProperty `json:"credit_card_type,omitempty"`
	// Mandatory when the account_role is ccAsset. Moment at which CC payment installments are asked for by the bank.
	MonthlyPaymentDate time.Time                   `json:"monthly_payment_date,omitempty"`
	LiabilityType      *LiabilityTypeProperty      `json:"liability_type,omitempty"`
	LiabilityDirection *LiabilityDirectionProperty `json:"liability_direction,omitempty"`
	// Mandatory when type is liability. Interest percentage.
	Interest       string                  `json:"interest,omitempty"`
	InterestPeriod *InterestPeriodProperty `json:"interest_period,omitempty"`
	Notes          string                  `json:"notes,omitempty"`
	// Latitude of the accounts's location, if applicable. Can be used to draw a map.
	Latitude float64 `json:"latitude,omitempty"`
	// Latitude of the accounts's location, if applicable. Can be used to draw a map.
	Longitude float64 `json:"longitude,omitempty"`
	// Zoom level for the map, if drawn. This to set the box right. Unfortunately this is a proprietary value because each map provider has different zoom levels.
	ZoomLevel int32 `json:"zoom_level,omitempty"`
}
