/*
 * Firefly III API v2.0.12
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-03-16T05:34:43+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that.
 *
 * API version: 2.0.12
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package firefly3

type BasicSummaryEntry struct {
	// This is a reference to the type of info shared, not influenced by translations or user preferences. The EUR value is a reference to the currency code. Possibilities are: balance-in-ABC, spent-in-ABC, earned-in-ABC, bills-paid-in-ABC, bills-unpaid-in-ABC, left-to-spend-in-ABC and net-worth-in-ABC.
	Key string `json:"key,omitempty"`
	// A translated title for the information shared.
	Title string `json:"title,omitempty"`
	// The amount as a float.
	MonetaryValue float64 `json:"monetary_value,omitempty"`
	// The currency ID of the associated currency.
	CurrencyId     string `json:"currency_id,omitempty"`
	CurrencyCode   string `json:"currency_code,omitempty"`
	CurrencySymbol string `json:"currency_symbol,omitempty"`
	// Number of decimals for the associated currency.
	CurrencyDecimalPlaces int32 `json:"currency_decimal_places,omitempty"`
	// The amount formatted according to the users locale
	ValueParsed string `json:"value_parsed,omitempty"`
	// Reference to a font-awesome icon without the fa- part.
	LocalIcon string `json:"local_icon,omitempty"`
	// A short explanation of the amounts origin. Already formatted according to the locale of the user or translated, if relevant.
	SubTitle string `json:"sub_title,omitempty"`
}
