/*
 * Firefly III API v2.0.12
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-03-16T05:34:43+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that.
 *
 * API version: 2.0.12
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package firefly3

type RecurrenceTransaction struct {
	Id          string `json:"id,omitempty"`
	Description string `json:"description"`
	// Amount of the transaction.
	Amount string `json:"amount"`
	// Foreign amount of the transaction.
	ForeignAmount string `json:"foreign_amount,omitempty"`
	// Submit either a currency_id or a currency_code.
	CurrencyId string `json:"currency_id,omitempty"`
	// Submit either a currency_id or a currency_code.
	CurrencyCode   string `json:"currency_code,omitempty"`
	CurrencySymbol string `json:"currency_symbol,omitempty"`
	// Number of decimals in the currency
	CurrencyDecimalPlaces int32 `json:"currency_decimal_places,omitempty"`
	// Submit either a foreign_currency_id or a foreign_currency_code, or neither.
	ForeignCurrencyId string `json:"foreign_currency_id,omitempty"`
	// Submit either a foreign_currency_id or a foreign_currency_code, or neither.
	ForeignCurrencyCode   string `json:"foreign_currency_code,omitempty"`
	ForeignCurrencySymbol string `json:"foreign_currency_symbol,omitempty"`
	// Number of decimals in the currency
	ForeignCurrencyDecimalPlaces int32 `json:"foreign_currency_decimal_places,omitempty"`
	// The budget ID for this transaction.
	BudgetId string `json:"budget_id,omitempty"`
	// The name of the budget to be used. If the budget name is unknown, the ID will be used or the value will be ignored.
	BudgetName string `json:"budget_name,omitempty"`
	// Category ID for this transaction.
	CategoryId string `json:"category_id,omitempty"`
	// Category name for this transaction.
	CategoryName string `json:"category_name,omitempty"`
	// ID of the source account. Submit either this or source_name.
	SourceId string `json:"source_id,omitempty"`
	// Name of the source account. Submit either this or source_id.
	SourceName string               `json:"source_name,omitempty"`
	SourceIban string               `json:"source_iban,omitempty"`
	SourceType *AccountTypeProperty `json:"source_type,omitempty"`
	// ID of the destination account. Submit either this or destination_name.
	DestinationId string `json:"destination_id,omitempty"`
	// Name of the destination account. Submit either this or destination_id.
	DestinationName string               `json:"destination_name,omitempty"`
	DestinationIban string               `json:"destination_iban,omitempty"`
	DestinationType *AccountTypeProperty `json:"destination_type,omitempty"`
	// Array of tags.
	Tags []string `json:"tags,omitempty"`
	// Optional. Use either this or the piggy_bank_name
	PiggyBankId string `json:"piggy_bank_id,omitempty"`
	// Optional. Use either this or the piggy_bank_id
	PiggyBankName string `json:"piggy_bank_name,omitempty"`
	// Optional. Use either this or the bill_name
	BillId string `json:"bill_id,omitempty"`
	// Optional. Use either this or the bill_id
	BillName string `json:"bill_name,omitempty"`
}
