/*
 * Firefly III API v2.0.12
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-03-16T05:34:43+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that.
 *
 * API version: 2.0.12
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package firefly3

type RecurrenceTransactionStore struct {
	Description string `json:"description"`
	// Amount of the transaction.
	Amount string `json:"amount"`
	// Foreign amount of the transaction.
	ForeignAmount string `json:"foreign_amount,omitempty"`
	// Submit either a currency_id or a currency_code.
	CurrencyId string `json:"currency_id,omitempty"`
	// Submit either a currency_id or a currency_code.
	CurrencyCode string `json:"currency_code,omitempty"`
	// Submit either a foreign_currency_id or a foreign_currency_code, or neither.
	ForeignCurrencyId string `json:"foreign_currency_id,omitempty"`
	// Submit either a foreign_currency_id or a foreign_currency_code, or neither.
	ForeignCurrencyCode string `json:"foreign_currency_code,omitempty"`
	// The budget ID for this transaction.
	BudgetId string `json:"budget_id,omitempty"`
	// Category ID for this transaction.
	CategoryId string `json:"category_id,omitempty"`
	// ID of the source account.
	SourceId string `json:"source_id"`
	// ID of the destination account.
	DestinationId string `json:"destination_id"`
	// Array of tags.
	Tags []string `json:"tags,omitempty"`
	// Optional.
	PiggyBankId string `json:"piggy_bank_id,omitempty"`
	// Optional.
	BillId string `json:"bill_id,omitempty"`
}
