/*
 * Firefly III API v2.0.12
 *
 * This is the documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. You may use the \"Authorize\" button to try the API below. This file was last generated on 2024-03-16T05:34:43+00:00  Please keep in mind that the demo site does not accept requests from curl, colly, wget, etc. You must use a browser or a tool like Postman to make requests. Too many script kiddies out there, sorry about that.
 *
 * API version: 2.0.12
 * Contact: james@firefly-iii.org
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package firefly3

type RuleStore struct {
	Title       string `json:"title"`
	Description string `json:"description,omitempty"`
	// ID of the rule group under which the rule must be stored. Either this field or rule_group_title is mandatory.
	RuleGroupId string `json:"rule_group_id"`
	// Title of the rule group under which the rule must be stored. Either this field or rule_group_id is mandatory.
	RuleGroupTitle string           `json:"rule_group_title,omitempty"`
	Order          int32            `json:"order,omitempty"`
	Trigger        *RuleTriggerType `json:"trigger"`
	// Whether or not the rule is even active. Default is true.
	Active bool `json:"active,omitempty"`
	// If the rule is set to be strict, ALL triggers must hit in order for the rule to fire. Otherwise, just one is enough. Default value is true.
	Strict bool `json:"strict,omitempty"`
	// If this value is true and the rule is triggered, other rules  after this one in the group will be skipped. Default value is false.
	StopProcessing bool               `json:"stop_processing,omitempty"`
	Triggers       []RuleTriggerStore `json:"triggers"`
	Actions        []RuleActionStore  `json:"actions"`
}
